--- linux-2.4.24.old/arch/i386/kernel/io_apic.c	Mon Jan  5 15:10:33 2004
+++ linux-2.4.24/arch/i386/kernel/io_apic.c	Thu Jan  8 14:40:03 2004
@@ -125,7 +125,7 @@
 			break;						\
 		reg = io_apic_read(entry->apic, 0x10 + R + pin*2);	\
 		reg ACTION;						\
-		io_apic_write(entry->apic, 0x10 + R + pin*2, reg);	\
+		io_apic_modify(entry->apic, reg);  \
 		if (!entry->next)					\
 			break;						\
 		entry = irq_2_pin + entry->next;			\
--- linux-2.4.24.old/include/asm-i386/io_apic.h	Mon Jan  5 15:34:34 2004
+++ linux-2.4.24/include/asm-i386/io_apic.h	Fri Jan  9 10:04:33 2004
@@ -123,6 +123,15 @@
 }
 
 /*
+ * Re-write a value: to be used for read-modify-write
+ * cycles where the read already set up the index register.
+ */
+static inline void io_apic_modify(unsigned int apic, unsigned int value)
+{
+       *(IO_APIC_BASE(apic)+4) = value;
+}
+
+/*
  * Synchronize the IO-APIC and the CPU by doing
  * a dummy read from the IO-APIC
  */
